

/* The basic Queue functionality provided here.  */
/* Partner file to queue.h   */

#include "queue.h"

void initialize(queue *q) {
  q -> count = 0;   
  q -> front = NULL;
  q -> rear = NULL; 
}

void enqueue(data d, queue *q) {
  elem *p;

  p = malloc(sizeof(elem));
  p->d = d;
  p->next = NULL;
  if (!empty(q)) {
    q->rear->next = p;
    q->rear = p;
  }
  else {
    q->front = p;
    q->rear = p;
  }
  q->count++;
}


data dequeue(queue *q) {
  data d;
  elem *p;

  p = q->front;
  d = p->d;
  q->front = p->next;
  q->count--;
  free(p);
  return d;
}


/* Note that a pre-requisite for applying 'top' is that the */
/* stack be non-empty.  Need to test with 'empty' function first */
data top(const queue *q) {
  return q->front->d;
}

boolean empty(const queue *q) {              /* const indicates that the */
  return ((boolean) (q->count == EMPTY));    /* stack won't be changed by */
}                                            /* the function.  */

boolean full(const queue *q) {
  return ((boolean) (q->count == FULL));
}


int main (void) {
  char str[] = "We all love C programming";
  int i;
  queue q;

  initialize(&q);
  printf("Input string: %s\n", str);
  for (i=0; str[i] != '\0'; ++i) 
    if (!full(&q) && ('a' <= str[i]) && (str[i] <= 'z'))
      enqueue(str[i], &q);
  printf("String off queue: ");
  while (!empty(&q))
    putchar(dequeue(&q));
  putchar('\n');
  return EXIT_SUCCESS;
}


