

/* The basic Stack functionality provided here.  */
/* Partner file to stack.h   */

#include "stack.h"

void initialize(stack *stk) {
  stk->count = 0;                  
  stk->top = NULL;       
}

void push(data d, stack *stk) {
  elem *p;

  p = malloc(sizeof(elem));
  p->d = d;
  p->next = stk->top;
  stk->top = p;
  stk->count++;
}

/* A pre-requisite for applying 'pop' is that the stack is non-empty.  */
/* Need to test emptyness with the 'empty' function first.  */
data pop(stack *stk) {
  data d;
  elem *p;

  assert(stk->count > 0);
  p = stk->top;
  d = p->d;
  stk->top = p->next;
  stk->count--;
  free(p);
  return d;
}


/* Note that a pre-requisite for applying 'top' is that the */
/* stack be non-empty.  Need to test with 'empty' function first */
data top(const stack *stk) {
  assert(stk->count > 0);
  return stk->top->d;
}

boolean empty(const stack *stk) {           
  return ((boolean) (stk->count == EMPTY)); 
}                                           

boolean full(const stack *stk) {
  return ((boolean) (stk->count == FULL));
}





