
/* Linked List implementation of a stack */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define    EMPTY    0
#define    FULL     10000

typedef    char                 data;
typedef    enum {false, true}   boolean;

struct elem {               /* structure of an element on the stack */
  data        d;             /* just one piece of data, and pointer */ 
  struct elem *next;         /* to 'next' cell */
};

typedef    struct elem      elem;  

struct stack {              /* Stack is just one element (the 'top'  */
  int       count;          /* one) plus also a count of items in    */
  elem     *top;            /* entire Stack.  */
};

typedef    struct stack     stack;

void       initialize(stack *stk);
void       push(data d, stack *stk);
data       pop(stack *stk);
data       top(const stack *stk);   
boolean    empty(const stack *stk); 
boolean    full(const stack *stk);  

